import java.util.Arrays;

public class MatricesTrasponerMultiplicar {

	private static void imprimirMatriz(int[][] m) {
		for (int i = 0; i < m.length; i++) {
			for (int j = 0; j < m[0].length; j++) {
				System.out.print(m[i][j] + "\t");
			}
			System.out.println();// Salto de linea entre filas
		}
	}

	public static void main(String[] args) {
		int[][] mat1 = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 }, { 9, 10, 11, 12 } };
		int[][] mat2 = { { 1, 1, 1 }, { 2, 2, 2 }, { 3, 3, 3 }, { 4, 4, 4 } };

		System.out.println("==== Matriz a trasponer ====");
		imprimirMatriz(mat1);
		System.out.println("---- Matriz traspuesta ----");
		imprimirMatriz(trasponer(mat1));
		System.out.println("==== Matrices a multiplicar ====");
		System.out.println("(A)");
		imprimirMatriz(mat1);
		System.out.println("(B)");
		imprimirMatriz(mat2);
		System.out.println("---- Matriz producto (AxB) ----");
		imprimirMatriz(multiplicarMatrices(mat1,mat2));
	}

	private static int[][] multiplicarMatrices(int[][] a, int[][] b) {
		// Para multiplicar columnas de A debe ser igual a filas de B
		if (a[0].length!=b.length)
			return null;
		//Creamos matriz producto: filas de A y columnas de B
		int [][] p=new int [a.length][b[0].length];
		//Obtenemos elementos de matriz producto
		for (int i = 0; i < p.length; i++) 
			for (int j = 0; j < p[0].length; j++) {
				p[i][j]=0; //Acumulamo productos sucesivos
				for (int k=0;k<a[0].length;k++)
					p[i][j]=p[i][j]+a[i][k]*b[k][j];
			}
		return p;
	}

	private static int[][] trasponer(int[][] m) {
		int[][] trasp = new int[m[0].length][m.length];

		for (int i = 0; i < m.length; i++)
			for (int j = 0; j < m[0].length; j++)
				trasp[j][i] = m[i][j];

		return trasp;
	}

}
