package ejemplocoches;

import java.util.Arrays;


public class Coche {
	private String modelo;
	private int color;
	private int velocidad;
	private Remolque rem;
	private int numSerie;
	private static int cnt=0;
	private Rueda [] r; //Ruedas 4  6

	
	public Coche(String m,int c,int velocidad, Remolque r, int numRuedas){
		
		if (numRuedas!=4 && numRuedas!=6){
			System.out.println("Solo se admiten 4 o 6 ruedas");
			return;
		}
		setModelo(m);
		color=c;
		this.velocidad=velocidad;
		rem=r;
		cnt++;
		numSerie=cnt;
		//Ponemos ruedas
		this.r=generarRuedas("Michelin", 225, 16, numRuedas);
	}
	public Coche(){
		this("Mafioso",1,0,null,4);
	}
	
	public Rueda [] generarRuedas(String m,int a,int r,int numero)
	{
		Rueda [] ruedas=new Rueda[numero];
		for (int i=0;i<ruedas.length;i++){
			ruedas[i]=new Rueda(m,a,r);
		}
		return ruedas;
	}


	
	public String getModelo() {
		return modelo;
	}
	
	public void setModelo(String m) {
		switch (m){
			case "Mafioso":
			case "Medio Huevo":
				modelo = m;
				break;
		}
	}
	public int getColor() {
		
		return color;
	}
	public void setColor(int color) {
		switch (color){
			case 1:
			case 2:
			case 3:
				this.color = color;
		}
	}
	public int getVelocidad() {
		return velocidad;
	}
	public void setVelocidad(int velocidad) {
		this.velocidad = velocidad;
	}
	
	public void dibujar()
	{
		switch (modelo){
		case "Mafioso":
			dibujarMafioso();
			break;
		case "Medio Huevo":
			dibujarMedioHuevo();
			break;
		}
	}

	private void dibujarMedioHuevo() {
		System.out.println("    *");
		System.out.println("  *****");
		System.out.println("*********");		
		System.out.println("  *   *");
	}

	private void dibujarMafioso() {
		System.out.println("***");
		System.out.println("***");
		System.out.println("********");		
		System.out.println("********");
		System.out.println(" *    *");
	}


	public Remolque getRem() {
		return rem;
	}


	public void setRem(Remolque rem) {
		this.rem = rem;
	}





	public int getNumSerie() {
		return numSerie;
	}


	public static int getCnt() {
		return cnt;
	}


	@Override
	public String toString() {
		return "Coche [modelo=" + modelo + ", color=" + color + ", velocidad="
				+ velocidad + ", rem=" + rem + ", numSerie=" + numSerie
				+ ", r=" + Arrays.toString(r) + "]";
	}
	public Rueda[] getR() {
		return r;
	}
	public void setR(Rueda[] r) {
		this.r = r;
	}



	
	
}
