package geometria;

public class Cuadrado {
	private Punto a;
	private Punto b;
	private Punto c;
	private Punto d;
	
	
	public Cuadrado(Punto a, Punto b, Punto c, Punto d) throws CuadradoException {
		
		if (a.equals(b)|| a.equals(c) || a.equals(d)
				 || b.equals(c) || b.equals(d) || c.equals(d)){
			throw new CuadradoException("Puntos superpuestos");
		}
		
		Recta ab=new Recta(a,b);
		Recta cd=new Recta(c,d);
		if (!ab.esParalela(cd)){
			throw new CuadradoException("Lados no paralelos");
		}
		if (a.distancia(c)!=b.distancia(d)){
			throw new CuadradoException("Diagonales difieren");
		}
		if (a.distancia(b)!=b.distancia(c)){
			throw new CuadradoException("Lados difieren");
		}
		
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
	}
	
	public Cuadrado(double xa,double ya,double xb,double yb,double xc,double yc,double xd,double yd) throws CuadradoException{
		this(new Punto(xa,ya),new Punto(xb,yb),new Punto(xc,yc),new Punto(xd,yd));
	}
	
	// Vertice sup. izq. + longitud de lado
	public Cuadrado(double xa,double ya,double lado) throws CuadradoException{
		this(new Punto(xa,ya),new Punto(xa+lado,ya),new Punto(xa+lado,ya-lado),new Punto(xa,ya-lado));
	}
	
	//longitud de lado (inf. izq, origen de coordenadas
	public Cuadrado(double lado) throws CuadradoException{
		this(new Punto(0,lado),new Punto(lado,lado),new Punto(lado,0),new Punto(0,0));
	}
	
	public double perimetro(){
		return a.distancia(b)+b.distancia(c)+c.distancia(d)+d.distancia(a);
	}
	
	public double area(){
		return a.distancia(b)*a.distancia(b);
	}
	
	public double longLado(){
		return a.distancia(b);
	}
	
	public double longDiagonal(){
		return a.distancia(c);
	}

	@Override
	public String toString() {
		return "Cuadrado [a=" + a + ", b=" + b + ", c=" + c + ", d=" + d + "]";
	}
}
