package geometria;

public class Triangulo {
	private Punto a;
	private Punto b;
	private Punto c;
	
	public Triangulo(Punto a, Punto b, Punto c) {
		
		if (a.equals(b)|| b.equals(c) || c.equals(a)){
			throw new TrianguloException("Puntos superpuestos");
		}
		Recta ab=new Recta(a,b);
		Recta bc=new Recta(b,c);
		if (ab.esParalela(bc)){
			throw new TrianguloException("Puntos alineados");
		}		
		this.a = a;
		this.b = b;
		this.c = c;
	}
	
	public Triangulo(double xa,double ya,double xb,double yb,double xc,double yc){
		this(new Punto(xa,ya),new Punto(xb,yb),new Punto(xc,yc));
	}
	
	public double perimetro(){
		return a.distancia(b)+b.distancia(c)+c.distancia(a);
	}
	
	public boolean esEquilatero(){
		return a.distancia(b)==b.distancia(c) && b.distancia(c)==c.distancia(a);
	}
	
	public boolean esIsosceles(){
		if (esEquilatero())
			return false;
		return a.distancia(b)==b.distancia(c) || b.distancia(c)==c.distancia(a) || c.distancia(a)==a.distancia(b);
	}
	
	public boolean esEscaleno(){
		return a.distancia(b)!=b.distancia(c) && b.distancia(c)!=c.distancia(a);
	}
	
}
