package ALPERSONA; 

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;

import Utilidades.Entrada;

public class GestionarPersonas {

	public static void main(String[] args) {
		
		ArrayList<Persona> per=new ArrayList<Persona>();
		char opcion;
		do{
			System.out.println("A-Alta");
			System.out.println("C-Consulta");
			System.out.println("M-Modificacion");
			System.out.println("B-Baja");
			System.out.println("L-Listado");
			System.out.println("P-Listado ordenado por nif");
			System.out.println("Q-Listado ordenado por nombre");
			System.out.println("R-Listado ordenado por edad");
			System.out.println("S-Salir");
						
			opcion=Entrada.caracter();
			
			switch(opcion){
			case 'A':
				alta(per);
				break;
			case 'C':
				consulta(per);
				break;
			case 'M':
				modificacion(per);
				break;
			case 'B':
				baja(per);
				break;	
			case 'L':
				listado(per);
				break;
			case 'P':
				listadoPorNif(per);
				break;
			case 'Q':
				listadoPorNombre(per);
				break;
			case 'R':
				listadoPorEdad(per);
				break;
			case 'S':
				break;
			default:
				System.out.println("Opcion incorrecta");
			}
		}while (opcion!='S');

	}

	private static void listadoPorEdad(ArrayList<Persona> per) {
		Collections.sort(per, new OrdenarPorEdad());
		for (int i=0;i<per.size();i++){
			System.out.println(per.get(i));	
		}
		
	}

	private static void listadoPorNombre(ArrayList<Persona> per) {
		Collections.sort(per);
		for (int i=0;i<per.size();i++){
			System.out.println(per.get(i));	
		}
		
	}

	private static void listadoPorNif(ArrayList<Persona> per) {
		Collections.sort(per, new OrdenarPorNif());
		for (int i=0;i<per.size();i++){
			System.out.println(per.get(i));	
		}
		
	}

	private static void listado(ArrayList<Persona> per) {
		for (int i=0;i<per.size();i++){
			System.out.println(per.get(i));	
		}
		
	}

	private static void baja(ArrayList<Persona> per) {
		System.out.print("NIF?");
		String nif=Entrada.cadena();
		int pos;
		if ((pos=buscar(per, nif))==-1){
			System.out.println("Este NIF NO EXISTE !!!");
			return;
		}
		
		per.remove(pos);
		
	}

	private static void modificacion(ArrayList<Persona> per) {
		System.out.print("NIF?");
		String nif=Entrada.cadena();
		int donde;
		if ((donde=buscar(per, nif))==-1){
			System.out.println("NO EXISTE !!!");
			return;
		}
		
		System.out.println("Nombre["+per.get(donde).getNombre()+"]?");
		String nuevo=Entrada.cadena();
		if (!nuevo.equals(""))
			per.get(donde).setNombre(nuevo);
		SimpleDateFormat sdf=new SimpleDateFormat("dd/MM/yyyy");
		System.out.println("Fecha Nacimiento (DD/MM/AAAA) ["+sdf.format(per.get(donde).getFechaNac())+"]?");
		nuevo=Entrada.cadena();
		if (!nuevo.equals("")){
			Date fn;
			try {
				sdf.setLenient(false);
				fn = sdf.parse(nuevo);
				per.get(donde).setFechaNac(fn);
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				System.out.println("Fecha incorrecta");
			}
		}
	}

	private static void consulta(ArrayList<Persona> per) {
		System.out.print("NIF?");
		String nif=Entrada.cadena();
		int donde;
		if ((donde=buscar(per, nif))==-1){
			System.out.println("NO EXISTE !!!");
			return;
		}
		
		System.out.println(per.get(donde));

	}

	private static void alta(ArrayList<Persona> per) {
		System.out.print("NIF?");
		String nif=Entrada.cadena();
		if (buscar(per, nif)!=-1){
			System.out.println("Este NIF YA EXISTE !!!");
			return;
		}

		System.out.print("Nombre?");
		String nombre=Entrada.cadena();
		System.out.print("Fecha de nacimiento (DD/MM/AAAA)?");
		SimpleDateFormat sdf=new SimpleDateFormat("dd/MM/yyyy");
		String cad=Entrada.cadena();
		Date fn;
		try {
			sdf.setLenient(false);
			fn = sdf.parse(cad);
			//Insertamos nueva persona en array
			per.add(new Persona(nif,nombre,fn));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			System.out.println("Fecha incorrecta");
		}
	}


	private static int buscar(ArrayList<Persona> per, String nif) {
		for (int i=0;i<per.size();i++){
				if (per.get(i).getNif().equals(nif))
					return i;	
			}
		return -1;
	}

}
