package ALPERSONA;

import java.text.SimpleDateFormat;
import java.util.Date;

public class Persona implements Comparable<Persona> {
	private String nif;
	private String nombre;
	private Date fechaNac;
	
	public Persona(String nif, String nombre, Date fechaNac) {
		this.nif = nif;
		this.nombre = nombre;
		this.fechaNac = fechaNac;
	}
	
	public int edad(){
		long ahora=System.currentTimeMillis();
		long nac=fechaNac.getTime();
		
		long edadEnAos=(ahora-nac)/1000L/3600L/24L/365L;//ms a aos
		
		return (int)edadEnAos;//Aos
		
	}

	public String getNif() {
		return nif;
	}

	public void setNif(String nif) {
		this.nif = nif;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}




	@Override
	public int compareTo(Persona o) {
		
		return this.nombre.compareTo(o.nombre);
	}

	public Date getFechaNac() {
		return fechaNac;
	}

	public void setFechaNac(Date fechaNac) {
		this.fechaNac = fechaNac;
	}

	@Override
	public String toString() {
		SimpleDateFormat sdf=new SimpleDateFormat("dd/MM/yyyy");
		return "Persona [nif=" + nif + ", nombre=" + nombre + ", fechaNac="
				+ sdf.format(fechaNac) + "("+edad()+")"+"]";
	}
		
}
