package CocheManualAutomatico;



public class UsoCoches {

	public static void main(String[] args) {

		/*
		 * Se inicializan los coches de cada tipo a null, as es posible proteger su inicializacin y usarlos
		 * en asignaciones y operaciones en el resto del cdigo sin warnings.
		 */
		CocheCambioAutomatico cocheAutomatico = null;
		CocheCambioManual cocheManual = null;

		/*
		 * Si la matricula que se pasa como parmetro al constructor no es correcta el coche no se 
		 * crear y dar un mensaje de error que se ha establecido en la clase Matrcula Invalida que hereda RuntimeException
		 */
		try {
			// Se intenta la creacin de CocheAutomtico.
			cocheAutomatico = new CocheCambioAutomatico("2352-TFR");
		} catch (MatriculaInvalida error) {
			// Si no se introduce la matrcula se imprimir el mensaje de error predefinido.
			System.out.println(error.getMessage());
		}

		try {
			// Se intenta la creacin de CocheManual.
			cocheManual = new CocheCambioManual("4362-GHT");
		} catch (MatriculaInvalida error) {
			// Si no se introduce la matrcula se imprimir el mensaje de error predefinido.
			System.out.println(error.getMessage());
		}

		/*
		 * Se crea un array de objetos Coche que podr contener objetos de los tipos Coche, CocheCambioManual y CocheCambioAutomtico,
		 * y se asignan las variables de objetos coche creadas anteriormente, aunque se haya fallado en su creacin, se puede asignar null
		 * al array.
		 */
		Coche arrayCoches[] = { cocheAutomatico, cocheManual };

		// Por si el coche no se creo se comprueba antes de invocar sus mtodos, que la referencia no sea null.
		if (arrayCoches[0] != null) {
			// arrayCoches[0].cambiarMarcha(1);
			arrayCoches[0].acelerar(10);
		}

		// Por si el coche no se creo se comprueba antes de invocar sus mtodos, que la referencia no sea null.
		if (arrayCoches[1] != null) {
			// arrayCoches[1].cambiarMarcha(1);
			arrayCoches[1].acelerar(10);
		}

		// Se imprimen los valores de las variables coche almacenadas en el array llamando a toString.
		System.out.println();
		for (int i = 0; i < arrayCoches.length; i++) {
			// Slo se llamara al mtodo toString de cada coche del arrayCohes si existe.
			if (arrayCoches[i] != null) {
				System.out.println(arrayCoches[i]);
			}
		}

		/*
		 *  El coche automtico no permite el cambio de marchas, ya que el no sobreescribe el mtodo cambiarMarcha
		 * y este es slo accesible desde las clases que heredan la clase coche (protected), sin embargo el coche
		 * manual si lo permite ya que lo sobreescribe y adems lo declara pblico.
		 * 
		 */
	}
}