package HIGHWAY;

public class Tramo implements Comparable<Tramo>{
	private double desde;
	private double hasta;
	
	public Tramo(double desde, double hasta) {
		super();
		if (hasta<=desde)
			throw new TramoInvalido("Hasta("+hasta+") debe ser posterior a desde("+desde+")");
		this.desde = desde;
		this.hasta = hasta;
	}

	@Override
	public String toString() {
		return "Tramo [desde=" + desde + ", hasta=" + hasta + "]";
	}

	public double getDesde() {
		return desde;
	}

	public void setDesde(double desde) {
		this.desde = desde;
	}

	public double getHasta() {
		return hasta;
	}

	public void setHasta(double hasta) {
		this.hasta = hasta;
	}
	
	public double distancia(){
		return hasta-desde;
	}

	@Override
	public int compareTo(Tramo o) {
		double dif=this.distancia()-o.distancia();
		if (dif < 0)
			return -1;
		else
		{
			if (dif > 0)
				return 1;
			else
				return 0;
		}
		
	}
}
