package Utilidades;

  
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;



public class Entrada {
	static String inicializar() {
		String buzon = "";
		InputStreamReader flujo = new InputStreamReader(System.in);
		BufferedReader teclado = new BufferedReader(flujo);
		try {
			buzon = teclado.readLine();
		} catch (Exception e) {
			System.out.append("Entrada incorrecta)");
		}
		return buzon;
	}

	public static int entero() {
		int valor = Integer.parseInt(inicializar());
		return valor;
	}

	public static double real() {
		double valor = Double.parseDouble(inicializar());
		return valor;
	}

	public static String cadena() {
		String valor = inicializar();
		return valor;
	}

	public static char caracter() {
		String valor = inicializar();
		return valor.charAt(0);
	}
	public static String cadenaValido(String menError, int maxFallos) {
		
		String n=null;
		int fallos=0;
		boolean error=false;
		do {
			try {
				error=false;
				n = cadena();
			} catch (NumberFormatException e) {
				error=true;
				fallos++;
				if (fallos == maxFallos) {
					throw new RuntimeException(maxFallos+" intentos invalidos");
				}
				if (menError == null)
					System.out.println("caracter incorrecto!!");
				else
					System.out.println(menError);
			}
		} while (error);
		return n;
		
	}
	
	public static Date fecha(String plantilla) throws FechaInvalida {
		String cad=cadena().toLowerCase();
		SimpleDateFormat sdf=new SimpleDateFormat(plantilla);
		try {
			sdf.setLenient(false);
			return sdf.parse(cad);
		} catch (ParseException e) { 
			System.out.println("Has introducido una fecha incorrecta");
			throw new FechaInvalida();
			
		}		
		}
	

	public static int enteroValido(String menError, int maxFallos) {
		
		int n=0;
		int fallos=0;
		boolean error=false;
		do {
			try {
				error=false;
				n = entero();
			} catch (NumberFormatException e) {
				error=true;
				fallos++;
				if (fallos == maxFallos) {
					throw new RuntimeException(maxFallos+" intentos invalidos");
				}
				if (menError == null)
					System.out.println("Numero incorrecto!!");
				else
					System.out.println(menError);
			}
		} while (error);
		return n;
		
	}
public static double realValido(String menError, int maxFallos) {
		
		double n=0;
		int fallos=0;
		boolean error=false;
		do {
			try {
				error=false;
				n = real();
			} catch (NumberFormatException e) {
				error=true;
				fallos++;
				if (fallos == maxFallos) {
					throw new RuntimeException(maxFallos+" intentos invalidos");
				}
				if (menError == null)
					System.out.println("Numero incorrecto!!");
				else
					System.out.println(menError);
			}
		} while (error);
		return n;
		
	}
	
	
}