package solucionMultiMedia;

public class Pelcula extends MultiMedia{
	private String actorPrincipal;
	private String actrizPrincipal;
	public Pelcula(String ttulo, String autor, Formato formato, 
							int duracin, String actor, String actriz){
		super(ttulo, autor, formato, duracin);
		if (actor == null && actriz ==null)
			throw new IllegalArgumentException("Tiene que haber al menos un protagonista");	
		actorPrincipal = actor;
		actrizPrincipal = actriz;
	}
	public Pelcula(String ttulo, String autor, String actor, String actriz){
		super(ttulo, autor);
		if (actor == null && actriz ==null)
			throw new IllegalArgumentException("Tiene que haber al menos un protagonista ");	
		actorPrincipal = actor;
		actrizPrincipal = actriz;
		//this(ttulo, autor, FORMATO_DEF, DURACION_DEF,  actor, actriZ); ERROR, las ctes no son visibles
							
	} 

	public boolean equals(Object obj) {
		if (getClass() != obj.getClass()) //Si obj no es una Pelicula
			return false;
		Pelcula other = (Pelcula) obj;
		if (!super.equals(other)) //Compara atributos de la clase padre MultiMedia
			return false;
		
		if (actorPrincipal == null) {
			if (other.actorPrincipal != null)
				return false;
		} else if (!actorPrincipal.equals(other.actorPrincipal))
			return false;
		if (actrizPrincipal == null) {
			if (other.actrizPrincipal != null)
				return false;
		} else if (!actrizPrincipal.equals(other.actrizPrincipal))
			return false;
		return true;
	}
	
	public String getActor(){
			return actorPrincipal;
	}
	public String getActriz(){
			return actrizPrincipal;
	}
	public String toString(){
			String s= "Protagonizado por: ";
				if (actrizPrincipal != null)
					s += actrizPrincipal;
				if (actorPrincipal != null)
					s += " Y " + actorPrincipal;									
			return super.toString() + "\n" + s;
	}
}